/*setup includes*/
#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include "tasks.h"
#include "../ls-b24/lsapi/lsapi.h"

/*setup constants*/
const char szAppName[] = "Tasks";
const char rcsRevision[] = "$Revision: r7.95 $"; // Our Version 
const char rcsId[] = "$Id: tasks.cpp,v r7.95 1999/07/09 00:22:00 jugg $"; // The Full RCS ID.
const int MAXTASKS = 16;
const int MAXICONS = 64;
const int MAXWIN = 200;

/*setup variables*/
IconList iconTag[MAXICONS];
IgnoreList ignoreTag[MAXTASKS];
PixList pixTag[MAXICONS];
TasksSettings ts;
TaskType tasks[MAXTASKS];
WinList tWinList[MAXWIN];

BOOL taskWrap, bgImgNone, minBgImgNone, selBgImgNone;
BOOL moveOnce;
char path[MAXLEN];
HCURSOR normalCursor, movingCursor;
HINSTANCE dll;
HWND parent, mainWin, deskTop, hints, curTask, lockCurTask, oldCurTask;
int numEnumWin, numIcon, numIgnore, numPix, numTasks, prevTasks;
int screenHeight, screenWidth;
POINT oldCursorPos;
UINT timer;

/*declare all the functions*/
BOOL GetTasksIgnore(char *ignoreTitle);
BOOL IsAppWindow(HWND hWNd);
BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam);
HICON GetIconFromWindow(HWND hWnD, BOOL bBigIcon);
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
int InWinList(HWND hwnd);
int GetTaskByWnd(HWND Hwnd);
int GetUnMovedNrTasks(void);
void CreateHints(HWND hWnd, char *txt);
void CreateTask(int i, HWND handle);
void DeleteTask(int i);
void GetNewTaskPos(int i);
void GetTasks(void);
void GetTasksIcon(int n);
void GetTasksPix(int n);
void HideMinAppBar(HWND HWnd);
void PackList(HWND hKill);
void PaintTask(int i);
void ReadConfig(void);
void ReadTasksIcon(void);
void ReadTasksIgnore(void);
void ReadTasksPix(void);
void ReArrangeTasks(BOOL all);
void RemoveHints(HWND hWnd);
void TaskPosition(int i, int tmpNumTasks);
void UpdateHints(HWND hwnD, char *txt);
/*The rest are !bang commands*/
void BottomTasks(void);
void GatherTasks(void);
void HideTasks(void);
void ShowTasks(void);
void ToggleTasks(void);
void TopTasks(void);

/*and here are all the functions*/
TasksSettings ReadSettings()
{
	TasksSettings settings;
	char tmp[MAXLEN], tmp2[MAXLEN], tmp3[MAXLEN], tmp4[MAXLEN], tmp5[MAXLEN];

	GetRCString("TasksDirection", tmp, "right", MAXLEN);
			settings.Direction = 2;  /*only needed if user enters an invalid parameter*/
		if (strcmp(tmp, "up") == 0)
			settings.Direction = 1;
		else if (strcmp(tmp, "right") == 0)
			settings.Direction = 2;
		else if (strcmp(tmp, "down") == 0)
			settings.Direction = 3;
		else if (strcmp(tmp, "left") == 0)
			settings.Direction = 4;
	settings.DragDistance = GetRCInt("TasksDragDistance", 4);
	settings.SpacingX = GetRCInt("TasksSpacingX", 0);
	settings.SpacingY = GetRCInt("TasksSpacingY", 0);
	settings.WrapCount = GetRCInt("TasksWrapCount", MAXTASKS + 1);
		if (settings.WrapCount > MAXTASKS || settings.WrapCount < 2)
		{
			settings.WrapCount = MAXTASKS;
			taskWrap = false;
		}
		else
			taskWrap = true;
	GetRCString("TasksWrapDirection", tmp2, "down", MAXLEN);
			settings.WrapDirection = 3;  /*only needed if user enters an invalid parameter*/
		if (strcmp(tmp2, "up") == 0)
			settings.WrapDirection = 1;
		else if (strcmp(tmp2, "right") == 0)
			settings.WrapDirection = 2;
		else if (strcmp(tmp2, "down") == 0)
			settings.WrapDirection = 3;
		else if (strcmp(tmp2, "left") == 0)
			settings.WrapDirection = 4;

	settings.Height = GetRCInt("TasksHeight", 32);
		if (settings.Height < 2) settings.Height = 32;
	settings.Width = GetRCInt("TasksWidth", 32);
		if (settings.Width < 2) settings.Width = 32;
	settings.X = GetRCInt("TasksX", 0);
	settings.Y = GetRCInt("TasksY", 0);

	settings.IconSize = GetRCInt("TasksIconSize", 16);
		if (settings.IconSize < 2) settings.IconSize = 16;
	settings.IconX = GetRCInt("TasksIconX", -2);
		if (settings.IconX < 0)
		{
			if (settings.IconX == -1)
				settings.IconX = 1;
			else if (settings.IconX == -3)
				settings.IconX = settings.Width - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.IconX = settings.Width/2 - settings.IconSize/2;
		}
	settings.IconY = GetRCInt("TasksIconY", -2);
		if (settings.IconY < 0)
		{
			if (settings.IconY == -1)
				settings.IconY = 1;
			else if (settings.IconY == -3)
				settings.IconY = settings.Height - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.IconY = settings.Height/2 - settings.IconSize/2;
		}
	settings.MinIconX = GetRCInt("TasksMinIconX", settings.IconX);
		if (settings.MinIconX < 0)
		{
			if (settings.MinIconX == -1)
				settings.MinIconX = 1;
			else if (settings.MinIconX == -3)
				settings.MinIconX = settings.Width - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.MinIconX = settings.Width/2 - settings.IconSize/2;
		}
	settings.MinIconY = GetRCInt("TasksMinIconY", settings.IconY);
		if (settings.MinIconY < 0)
		{
			if (settings.MinIconY == -1)
				settings.MinIconY = 1;
			else if (settings.MinIconY == -3)
				settings.MinIconY = settings.Height - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.MinIconY = settings.Height/2 - settings.IconSize/2; //Center the Icon by default for any other negative value.
		}
	settings.SelIconX = GetRCInt("TasksSelIconX", settings.IconX);
		if (settings.SelIconX < 0)
		{
			if (settings.SelIconX == -1)
				settings.SelIconX = 1;
			else if (settings.SelIconX == -3)
				settings.SelIconX = settings.Width - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.SelIconX = settings.Width/2 - settings.IconSize/2;
		}
	settings.SelIconY = GetRCInt("TasksSelIconY", settings.IconY);
		if (settings.SelIconY < 0)
		{
			if (settings.SelIconY == -1)
				settings.SelIconY = 1;
			else if (settings.SelIconY == -3)
				settings.SelIconY = settings.Height - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.SelIconY = settings.Height/2 - settings.IconSize/2; //Center the Icon by default for any other negative value.
		}

	settings.PixX = GetRCInt("TasksPixX", 1);
	settings.PixY = GetRCInt("TasksPixY", 1);
	settings.MinPixX = GetRCInt("TasksMinPixX", settings.PixX);
	settings.MinPixY = GetRCInt("TasksMinPixY", settings.PixY);
	settings.SelPixX = GetRCInt("TasksSelPixX", settings.PixX);
	settings.SelPixY = GetRCInt("TasksSelPixY", settings.PixY);
		
	settings.AlwaysOnTop = GetRCBool("TasksAlwaysOnTop", TRUE);
	settings.AutoArrange = GetRCBool("TasksAutoArrange", TRUE);
	settings.HideMinAppBar = GetRCBool("TasksHideMinAppBar", TRUE);
	settings.InjTray = GetRCBool("TasksInjTray", TRUE);
	settings.MoveAll = GetRCBool("TasksMoveAll", TRUE);
	settings.NoMinimizeOnClick = GetRCBool("TasksNoMinimizeOnClick", TRUE);
	settings.NoMove = GetRCBool("TasksNoMove", TRUE);
	settings.OnlyMinimized = GetRCBool("TasksOnlyMinimized", TRUE);
	settings.StartHidden = GetRCBool("TasksStartHidden", TRUE);

	settings.NoHints = GetRCBool("TasksNoHints", TRUE);
	settings.NoIcons = GetRCBool("TasksNoIcons", TRUE);
	settings.HighLightMinimized = GetRCBool("TasksHighLightMinimized", TRUE);
	settings.HighLightSelected = GetRCBool("TasksHighLightSelected", TRUE);

	settings.BgColor = GetRCColor("TasksBgColor", 0xFF00FF);
	settings.DarkColor = GetRCColor("TasksDarkColor", 0xFF00FF);
	settings.LightColor = GetRCColor("TasksLightColor", 0xFF00FF);
	settings.MinBgColor = GetRCColor("TasksMinBgColor", settings.BgColor);
	settings.MinDarkColor = GetRCColor("TasksMinDarkColor", settings.DarkColor);
	settings.MinLightColor = GetRCColor("TasksMinLightColor", settings.LightColor);
	settings.SelBgColor = GetRCColor("TasksSelBgColor", settings.BgColor);
	settings.SelDarkColor = GetRCColor("TasksSelDarkColor", settings.DarkColor);
	settings.SelLightColor = GetRCColor("TasksSelLightColor", settings.LightColor);

	GetRCString("TasksBackImage", tmp3, ".none", MAXLEN);
			bgImgNone = true;
		if (strcmp(".none", tmp3))
		{
			settings.BackImage = LoadLSImage(tmp3, NULL);
			bgImgNone = false;
		}
		else
			settings.BackImage = NULL;

	GetRCString("TasksMinBackImage", tmp4, "", MAXLEN); /*By using "" as the default, it uses the TasksBackImage.*/
			minBgImgNone = false;
		if (strcmp(".none", tmp4))
			settings.MinBackImage = LoadLSImage(tmp4, NULL);
		else
		{
			settings.MinBackImage = NULL;
			minBgImgNone = true;
		}

	GetRCString("TasksSelBackImage", tmp5, "", MAXLEN); /*By using "" as the default, it uses the TasksBackImage.*/
			selBgImgNone = false;
		if (strcmp(".none", tmp5))
			settings.SelBackImage = LoadLSImage(tmp5, NULL);
		else
		{
			settings.SelBackImage = NULL;
			selBgImgNone = true;
		}

	settings.TitleHeight = GetRCInt("TasksTitleHeight", 12); /*The Title settings here align it centered along the bottom of a 32x32 tile.*/
		if (settings.TitleHeight < 2) settings.TitleHeight = 12;
	settings.TitleWidth = GetRCInt("TasksTitleWidth", 28);
		if (settings.TitleWidth < 2) settings.TitleWidth = 28;
	settings.TitleX = GetRCInt("TasksTitleX", 2);
	settings.TitleY = GetRCInt("TasksTitleY", 18);

	settings.TitleIconX = GetRCInt("TasksTitleIconX", -2);
		if (settings.TitleIconX < 0)
		{
			if (settings.TitleIconX == -1)
				settings.TitleIconX = 1;
			else if (settings.TitleIconX == -3)
				settings.TitleIconX = settings.Width - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleIconX = settings.Width/2 - settings.IconSize/2;
		}
	settings.TitleIconY = GetRCInt("TasksTitleIconY", -1);
		if (settings.TitleIconY < 0)
		{
			if (settings.TitleIconY == -1)
				settings.TitleIconY = 1;
			else if (settings.TitleIconY == -3)
				settings.TitleIconY = settings.Height - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleIconY = settings.Height/2 - settings.IconSize/2;
		}
	settings.TitlePixX = GetRCInt("TasksTitlePixX", settings.PixX);
	settings.TitlePixY = GetRCInt("TasksTitlePixY", settings.PixY);

	settings.TitleFontSize = GetRCInt("TasksTitleFontSize", 10);
		if (settings.TitleFontSize < 2) settings.TitleFontSize = 10;
	settings.TitleMinFontSize = GetRCInt("TasksTitleMinFontSize", settings.TitleFontSize);
		if (settings.TitleMinFontSize < 2) settings.TitleMinFontSize = settings.TitleFontSize;
	settings.TitleSelFontSize = GetRCInt("TasksTitleSelFontSize", settings.TitleFontSize);
		if (settings.TitleSelFontSize < 2) settings.TitleSelFontSize = settings.TitleFontSize;

	settings.Titles = GetRCBool("TasksTitles", TRUE);
	settings.TitleMinimized = GetRCBool("TasksTitleMinimized", TRUE);
	settings.TitleNoEllipsis = GetRCBool("TasksTitleNoEllipsis", TRUE);
	settings.TitleSelected = GetRCBool("TasksTitleSelected", TRUE);
	settings.TitleUnderline = GetRCBool("TasksTitleUnderline", TRUE);

	GetRCString("TasksTitleFont", settings.TitleFont, "Arial", MAXLEN);
	GetRCString("TasksTitleMinFont", settings.TitleMinFont, settings.TitleFont, MAXLEN);
	GetRCString("TasksTitleSelFont", settings.TitleSelFont, settings.TitleFont, MAXLEN);

	settings.TitleBgColor = GetRCColor("TasksTitleBgColor", 0xFF00FF);
	settings.TitleDarkColor = GetRCColor("TasksTitleDarkColor", 0xFF00FF);
	settings.TitleFontColor = GetRCColor("TasksTitleFontColor", 0xC0C0C0); /*'C0C0C0' is a light gray*/
	settings.TitleLightColor = GetRCColor("TasksTitleLightColor", 0xFF00FF);
	settings.TitleMinBgColor = GetRCColor("TasksTitleMinBgColor", settings.TitleBgColor);
	settings.TitleMinDarkColor = GetRCColor("TasksTitleMinDarkColor", settings.TitleDarkColor);
	settings.TitleMinFontColor = GetRCColor("TasksTitleMinFontColor", settings.TitleFontColor);
	settings.TitleMinLightColor = GetRCColor("TasksTitleMinLightColor", settings.TitleLightColor);
	settings.TitleSelBgColor = GetRCColor("TasksTitleSelBgColor", settings.TitleBgColor);
	settings.TitleSelDarkColor = GetRCColor("TasksTitleSelDarkColor", settings.TitleDarkColor);
	settings.TitleSelFontColor = GetRCColor("TasksTitleSelFontColor", settings.TitleFontColor);
	settings.TitleSelLightColor = GetRCColor("TasksTitleSelLightColor", settings.TitleLightColor);
	return settings;
}

int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
	UINT Msgs[2];
	int i;
	dll = dllInst;
	strcpy(path, szPath);
	parent = ParentWnd;
	screenWidth = GetSystemMetrics(SM_CXSCREEN);
	screenHeight = GetSystemMetrics(SM_CYSCREEN);
	numEnumWin = 0;
	moveOnce = false;
	curTask = NULL;
	lockCurTask = NULL;
	oldCurTask = NULL;
	deskTop = NULL;
	deskTop = FindWindow("DesktopBackgroundClass", NULL);
	if (!deskTop)
		deskTop = GetDesktopWindow();
	{
		WNDCLASS wc;
		memset(&wc,0,sizeof(wc));
		wc.cbClsExtra = NULL;
		wc.cbWndExtra = NULL;
		wc.hbrBackground = NULL;
		wc.hCursor = NULL;
		wc.hIcon = NULL;
		wc.hInstance = dllInst;
		wc.lpfnWndProc = WndProc;
		wc.lpszClassName = szAppName;
		wc.lpszMenuName = NULL;
		wc.style = NULL;
		if (!RegisterClass(&wc)) 
		{
			MessageBox(parent,"Error registering window class","Tasks",MB_OK);
			return 1;
		}
	}
	movingCursor = LoadCursor(NULL, IDC_UPARROW);
	normalCursor = LoadCursor(NULL, IDC_ARROW);
	if (!normalCursor)
		LoadCursor(NULL, IDC_ARROW);
	for (i = 0; i < MAXTASKS; i++)
	{
		tasks[i].hwnd = NULL;
		tasks[i].pix = NULL;
		tasks[i].appHandle = NULL;
		tasks[i].appTitle = NULL;
		tasks[i].appClass = NULL;
		tasks[i].icon = NULL;
	}
	for (i=0;i<MAXWIN;i++)
		tWinList[i].handle = NULL;
	ts = ReadSettings();
	if (!ts.NoIcons)
		ReadTasksIcon();
	ReadTasksIgnore();
	ReadTasksPix();
	mainWin = CreateWindowEx(WS_EX_TOOLWINDOW, szAppName, "Timer", WS_CHILD, 0,0,0,0, parent, NULL, dll, NULL);
	if (!mainWin) 
	{						   
		MessageBox(parent,"Error creating window","Tasks",MB_OK);
		return 1;
	}
	if (!ts.NoHints)
	{
		hints = CreateWindow(TOOLTIPS_CLASS,(LPSTR) NULL,TTS_ALWAYSTIP,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,(HMENU) NULL,dll,NULL);
		if (!hints) 
		{
			MessageBox(parent, "Error creating hints window", "Tasks", MB_OK);
			return 1;
		}
		SetWindowPos(hints, HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
	}
	{
		Msgs[0] = LM_GETREVID;
		Msgs[1] = 0;
		SendMessage(parent, LM_REGISTERMESSAGE, (WPARAM) mainWin, (LPARAM) Msgs);
	}
	SetWindowLong(mainWin, GWL_USERDATA, magicDWord);
	ShowWindow(mainWin, SW_HIDE);
	AddBangCommand("!BOTTOMTASKS", BottomTasks);
	AddBangCommand("!GATHERTASKS", GatherTasks);
	AddBangCommand("!HIDETASKS", HideTasks);
	AddBangCommand("!SHOWTASKS", ShowTasks);
	AddBangCommand("!TOGGLETASKS", ToggleTasks);
	AddBangCommand("!TOPTASKS", TopTasks);
	timer = SetTimer(mainWin, 0, 250, NULL);
	return 0;
}

void quitModule(HINSTANCE dllInst)
{
	UINT Msgs[2];
	int i;
	if (timer)
		KillTimer(NULL, timer);
	for(i = 0; i < numTasks; i++)
		DeleteTask(i);
	for(i = 0; i < numPix; i++)
	{
		delete [] pixTag[numPix].match;
		delete [] pixTag[numPix].pix;
	}
	for(i = 0; i < numIcon; i++)
	{
		delete [] iconTag[numIcon].match;
		delete [] iconTag[numIcon].name;
	}
	for(i = 0; i < numIgnore; i++)
		delete [] ignoreTag[numIgnore].match;
	if (ts.BackImage)
		DeleteObject(ts.BackImage);
	if (ts.MinBackImage)
		DeleteObject(ts.MinBackImage);
	if (ts.SelBackImage)
		DeleteObject(ts.SelBackImage);
	if (ts.HideMinAppBar)
		ArrangeIconicWindows(GetDesktopWindow());
	DestroyWindow(mainWin);
	if (!ts.NoHints) 
		DestroyWindow (hints);
	{
		Msgs[0] = LM_GETREVID;
		Msgs[1] = 0;
		SendMessage(parent, LM_UNREGISTERMESSAGE, (WPARAM) mainWin, (LPARAM) Msgs);
	}
	RemoveBangCommand("!BOTTOMTASKS");
	RemoveBangCommand("!GATHERTASKS");
	RemoveBangCommand("!HIDETASKS");
	RemoveBangCommand("!SHOWTASKS");
	RemoveBangCommand("!TOGGLETASKS");
	RemoveBangCommand("!TOPTASKS");
	UnregisterClass(szAppName,dllInst);
	return;
}

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam)
{/*Modified code from stock LS desktop.dll*/
	/*need to make sure that we aren't going above our limit*/
	if (!(numEnumWin < MAXWIN)) return FALSE;
	/*Really tho, we could probably just use one tasklist anyway, instead of using both tWinList[] and tasks[], and that'd probably clear up a few other inconsistencies*/
	/*added the extra checks below, to filter out of some of the extra junk, that things like Netscape loads a 100 of that cause our array to fill up too quickly!*/
	if (!InWinList(hwnd) && (GetWindowLong(hwnd, GWL_STYLE) & WS_VISIBLE) && (hwnd != FindWindow("tooltips_class32","")))
	{
		tWinList[numEnumWin].handle = hwnd;
		numEnumWin++;
	}
	return TRUE;
}

BOOL GetTasksIgnore(char *ignoreStr)
{
	int i;
	for (i = 0; i < numIgnore; i++)
	{
		if (strstr(ignoreStr, ignoreTag[i].match))
		return true;
	}
	return false;
}

BOOL IsAppWindow(HWND hWNd)
{/*This code is from re5ource's Popups*/
	BOOL bResult = TRUE;
	LONG nStyle;
	HWND hOwner, hParent;

	/*if it is a WS_CHILD or not WS_VISIBLE, fail it*/
	nStyle = GetWindowLong(hWNd, GWL_STYLE);	
	if((nStyle & WS_CHILD) || !(nStyle & WS_VISIBLE))
		bResult = FALSE;
	/*if the window is a WS_EX_TOOLWINDOW fail it*/
	nStyle = GetWindowLong(hWNd, GWL_EXSTYLE);
	if(nStyle & WS_EX_TOOLWINDOW)
		bResult = FALSE;
	/*If this has an owner, then only accept this window
		if the partent is not accepted*/
	hOwner = GetWindow(hWNd, GW_OWNER);
	if(hOwner && bResult)
		bResult = !IsAppWindow(hOwner);
	/*if it has a parent, fail*/
	hParent = GetParent(hWNd);
	if(hParent && hParent)// != GetDesktopWindow() && hParent != FindWindow("RunDLL", NULL)) /*Added check so if the parent window is DesktopWindow don't fail - jugg*/
		bResult = FALSE;
	/*if the magicDWord, fail*/
	if(GetWindowLong(hWNd, GWL_USERDATA) == 0x49474541)
		bResult = FALSE;
	return bResult;
}

HICON GetIconFromWindow(HWND hWnD, BOOL bBigIcon)
{/*This code is a mix from re5ource's Popups and Fahim's lsTasks*/
	HICON a;
	if (!bBigIcon)
	{
		SendMessageTimeout(hWnD, WM_GETICON, 0, 0, 0, 1000, (unsigned long*)&a);
		if (!a) a = (HICON)GetClassLong(hWnD, GCL_HICONSM);
		if (!a) SendMessageTimeout(hWnD, WM_GETICON, 1, 0, 0, 1000, (unsigned long*)&a);
		if (!a) a = (HICON)GetClassLong(hWnD, GCL_HICON);
		if (!a) SendMessageTimeout(hWnD, WM_QUERYDRAGICON, 0, 0, 0, 1000, (unsigned long*)&a);
	} else {
		SendMessageTimeout(hWnD, WM_GETICON, 1, 0, 0, 1000, (unsigned long*)&a);
		if (!a) a = (HICON)GetClassLong(hWnD, GCL_HICON);
		if (!a) SendMessageTimeout(hWnD, WM_QUERYDRAGICON, 0, 0, 0, 1000, (unsigned long*)&a);
		if (!a) SendMessageTimeout(hWnD, WM_GETICON, 0, 0, 0, 1000, (unsigned long*)&a);
		if (!a) a = (HICON)GetClassLong(hWnD, GCL_HICONSM);
	}
	if (!a) a = LoadIcon(NULL, MAKEINTRESOURCE(IDI_APPLICATION));
	return a;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case LM_GETREVID:
		{
			char *buf = (char *) lParam;

			if (wParam == 0)
			{
				strcpy(buf, "tasks.dll: ");
				strcat(buf, &rcsRevision[11]);
				buf[strlen(buf)-1] = '\0';
			}
			else if (wParam == 1)
			{
				strcpy(buf, &rcsId[1]);
				buf[strlen(buf)-1] = '\0';
			}
			else
				strcpy(buf, "");
			return strlen(buf);
		}
		case WM_TIMER:
		{
			oldCurTask = curTask;
			curTask = GetForegroundWindow();
			if (oldCurTask != curTask)
				lockCurTask = oldCurTask;
			PackList(NULL);/*Get rid of old apps in tasks WinList*/
			EnumWindows(EnumWindowsProc, NULL);/*Add new apps to tasks WinList*/
			GetTasks();/*Update task windows*/
			return 0;
		}
		//case WM_QUERYENDSESSION:
			//return SendMessage(parent,message,wParam,lParam);
		//case WM_CREATE:
			//return 0;
		case WM_ERASEBKGND:
		{
			if (ts.BgColor == 0x00FF00FF || ts.AlwaysOnTop) /* no point in doing this if not transparent.  But because of a wierd quirk must have it when always on top, -jugg*/
				PaintDesktop((HDC)wParam); // transparency (Maduin)
			return 1;
		}
		case WM_PAINT:
		{
			int n = GetTaskByWnd(hwnd);
			if (n != -1)
				PaintTask(n);
			return 0;
		}
		case WM_LBUTTONDOWN:
		{
			int n = GetTaskByWnd(hwnd);
			if (n != -1)
			{
				GetCursorPos(&oldCursorPos);
				SetCapture(tasks[n].hwnd);
				moveOnce = true;
			}
			return 0;
		}
		case WM_MOUSEMOVE:
		{
			int n = GetTaskByWnd(hwnd);
			if (n != -1)
			{
				if ((wParam == MK_LBUTTON) && !ts.NoMove)
				{
					POINT cursorPos;
					GetCursorPos(&cursorPos);
					if (cursorPos.x == oldCursorPos.x && cursorPos.y == oldCursorPos.y)
					{
						if (GetCursor() != normalCursor)
							SetCursor(normalCursor);
					}
					else
					{
						if (GetCursor() != movingCursor)
							SetCursor(movingCursor);
					}
					SetWindowPos(tasks[n].hwnd, 0, tasks[n].x - (oldCursorPos.x - cursorPos.x), tasks[n].y - (oldCursorPos.y - cursorPos.y), ts.Width, ts.Height, NULL); //SWP_NOZORDER|SWP_NOACTIVATE
					if (ts.BgColor == 0x00FF00FF || moveOnce) /*no point in doing this if not transparent, and do do it the first move no matter what, so it clears clipped junk. -jugg*/
						InvalidateRect(hwnd, NULL, TRUE);/*transparency during move, causes some flicker, but it works (Maduin)*/
					moveOnce = false;
				}
				else
				{
					if (GetCursor() != normalCursor)
						SetCursor(normalCursor);
					if (!ts.NoHints) 
					{
						MSG TooltipMessage;
						TooltipMessage.hwnd=tasks[n].hwnd;
						TooltipMessage.message=message;
						TooltipMessage.wParam=wParam;
						TooltipMessage.lParam=lParam;
						SendMessage(hints,TTM_RELAYEVENT,0,(LPARAM)&TooltipMessage);
						SetWindowPos(hints,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
					}
				}
			}
			return 0;
		}
		case WM_LBUTTONUP:
		{
			POINT cursorPos;
			GetCursorPos(&cursorPos);
			ReleaseCapture();
			int n = GetTaskByWnd(hwnd);
			if (n != -1)
			{
				if ((abs(oldCursorPos.x - cursorPos.x) <= ts.DragDistance && abs(oldCursorPos.y - cursorPos.y) <= ts.DragDistance) || ts.NoMove)
				{
					SetWindowPos(tasks[n].hwnd, 0, tasks[n].x, tasks[n].y, ts.Width, ts.Height, NULL); //SWP_NOZORDER|SWP_NOACTIVATE
					if (IsIconic(tasks[n].appHandle))
					{
						ShowWindow(tasks[n].appHandle, SW_RESTORE);
						SetForegroundWindow(tasks[n].appHandle);
						tasks[n].IsActive = true;
						tasks[n].IsIconic = false;
					}
					else if (!ts.NoMinimizeOnClick && (tasks[n].appHandle == curTask || (curTask != tasks[n].appHandle && curTask == tasks[n].hwnd && lockCurTask == tasks[n].appHandle)))
					{
						ShowWindow(tasks[n].appHandle, SW_MINIMIZE);
						tasks[n].IsActive = false;
						tasks[n].IsIconic = true;
					}
					else if (!IsIconic(tasks[n].appHandle))
					{
						SendMessage(parent, LM_BRINGTOFRONT, 0, (long)tasks[n].appHandle);/*I think this is for VWM's, so that it changes VW's on task focus... -jugg*/
						SetForegroundWindow(tasks[n].appHandle);
						tasks[n].IsActive = true;
						tasks[n].IsIconic = false;
					}
				}
				else if (!ts.NoMove) /*move*/
				{
					tasks[n].x -= oldCursorPos.x - cursorPos.x;
					tasks[n].y -= oldCursorPos.y - cursorPos.y;
					if (ts.MoveAll)
					{
						if (ts.Direction == 1 || (taskWrap && ts.WrapDirection == 1))
							ts.Y = tasks[n].y + ts.Height;
						else
							ts.Y = tasks[n].y;
						if (ts.Direction == 4 || (taskWrap && ts.WrapDirection == 4))
							ts.X = tasks[n].x + ts.Width;
						else
							ts.X = tasks[n].x;
						ReArrangeTasks(true);
					}
					else
					{
						SetWindowPos(tasks[n].hwnd, 0, tasks[n].x, tasks[n].y, ts.Width, ts.Height, NULL); //SWP_NOZORDER|SWP_NOACTIVATE
						if (ts.AutoArrange && !tasks[n].IsMoved)
						{
							tasks[n].IsMoved = true;
							ReArrangeTasks(false);
						}
					}
				}/*Have to force a complete redraw here...*/
				InvalidateRect(tasks[n].hwnd, NULL, TRUE);
			}
			if (GetCursor() != normalCursor)
				SetCursor(normalCursor);
			lockCurTask = NULL;
			return 0;
		}
		//case WM_MOUSEACTIVATE:
		//{
			////PostMessage(parent, 9185, 0, 0); /*Tells litestep it has been selected*/
			////SendMessage(parent, 9183, (int)HIWORD(lParam), (int)LOWORD(lParam)); /*Close any popup open*/
			////return MA_ACTIVATE;
			//return MA_NOACTIVATE;
		//}
			////SendMessage(parent, 9185, 0, 0); /*Tells litestep it has been selected*/
		/*case WM_ACTIVATE:
		{
			if (LOWORD(wParam) == WA_ACTIVE)
				if (GetTaskByWnd((HWND)lParam) == -1 && !IsIconic((HWND)lParam))
					SetForegroundWindow((HWND)lParam);
			return 0;
		}*/
		/*case WM_ACTIVATE:
		{
			if (LOWORD(wParam) == WA_ACTIVE)
			{
				if (GetTaskByWnd((HWND)lParam) == -1 && !IsIconic((HWND)lParam))
					SetActiveWindow((HWND)lParam);
				return 0;
			}
			break;
		}*/
		case WM_RBUTTONDOWN:
		{/*Open system popup menu - I Referenced Fahim's lsTasks for syntax -jugg*/
			BOOL result;
			int n = GetTaskByWnd(hwnd);
			if (n != -1)
			{
				//SendMessage(tasks[n].appHandle, WM_INITMENUPOPUP, (long)GetSystemMenu(tasks[n].appHandle, FALSE), MAKELPARAM(0,TRUE));
				result = TrackPopupMenu(GetSystemMenu(tasks[n].appHandle, FALSE), TPM_RETURNCMD|TPM_RIGHTBUTTON, (int)LOWORD(GetMessagePos()), (int)HIWORD(GetMessagePos()), 0, hwnd, NULL);
				if (result)
				{
					if (result != SC_MINIMIZE && result != SC_ICON)
						SetForegroundWindow(tasks[n].appHandle);
					SendMessage(tasks[n].appHandle, WM_SYSCOMMAND, (WPARAM)result, GetMessagePos());
				}
			}
			return 0;
		}
		//case WM_RBUTTONUP:
			//return 0;
		case WM_MBUTTONUP: /*LiteStep popup menu*/
		{
			SendMessage(parent, 9182, (int)HIWORD(lParam), (int)LOWORD(lParam));
			return 0;
		}
		//case WM_KEYDOWN: 
		//case WM_KEYUP:
			//PostMessage(parent,message,wParam,lParam);
		//return 0;
	}
	return DefWindowProc(hwnd,message,wParam,lParam);
}

int GetTaskByWnd(HWND Hwnd)
{
	int i;
	for (i = 0;i < numTasks ; i++)
		if (tasks[i].hwnd == Hwnd)
			return i;
	return -1;
}

int GetUnMovedNrTasks(void)
{
	int result = 0;
	for (int i = 0; i < numTasks; i++)
		if (!tasks[i].IsMoved)
			result++;
	return result;
}

int InWinList(HWND hwnd)
{/*Modified code from stock LS desktop.dll*/
	int i;
	if (!hwnd)
		return 0;
	for (i=0;i<numEnumWin;i++)
		if (tWinList[i].handle == hwnd) 
			return i+1;
	return 0;
}

void CreateHints(HWND hWnd, char *txt)
{ /*from the original ls code (shortcuts)*/
	RECT r;
	GetClientRect(hWnd, &r);
	TOOLINFO ti;/*tool information*/
	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = TTF_SUBCLASS;
	ti.hwnd = hWnd;
	ti.hinst = dll;
	ti.uId = 0;
	ti.lpszText = txt;
	ti.rect = r;
	SendMessage(hints, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
	return;
}

void CreateTask(int i, HWND handle)
{
	HWND hWnD = NULL;
	char titleTmp[MAXLEN], classTmp[MAXLEN];
	GetNewTaskPos(i);
	/*added code for always ontop -maduin*/
	hWnD = CreateWindowEx(WS_EX_TOOLWINDOW|WS_EX_TOPMOST, szAppName, "", WS_POPUP, tasks[i].x, tasks[i].y, ts.Width, ts.Height, NULL, NULL, dll, NULL);
	//hWnD = CreateWindowEx(WS_EX_TOOLWINDOW|WS_EX_TOPMOST, szAppName, "", WS_CHILD, tasks[i].x, tasks[i].y, ts.Width, ts.Height, deskTop, NULL, dll, NULL);
	if (!hWnD) 
	{						   
		MessageBox(parent,"Error creating window","Tasks",MB_OK);
		return;
	}
	if (ts.InjTray)
		SetParent(hWnD,FindWindow("jTray", NULL));
	else if (!ts.AlwaysOnTop)
		SetParent(hWnD, deskTop);
	//if (ts.AlwaysOnTop) SetParent(hWnD, NULL);
	tasks[i].hwnd = hWnD;
	tasks[i].appHandle = handle;
	SetWindowLong(tasks[i].hwnd, GWL_USERDATA, magicDWord);
	{
		GetWindowText(handle, (char *)&titleTmp, MAXLEN);
		tasks[i].appTitle = new char[strlen(titleTmp) + 1];
		strcpy(tasks[i].appTitle, titleTmp);
	}
	{
		GetClassName(handle, (char *)&classTmp, MAXLEN);
		tasks[i].appClass = new char[strlen(classTmp) + 1];
		strcpy(tasks[i].appClass, classTmp);
	}
	tasks[i].IsActive = (GetForegroundWindow() == handle);
	tasks[i].IsIconic = IsIconic(handle);
		if (tasks[i].IsIconic && ts.HideMinAppBar) HideMinAppBar(tasks[i].appHandle);
	tasks[i].IsMoved  = false;
	tasks[i].IsCustomIcon = false;
	if (!ts.NoIcons)
		GetTasksIcon(i);
	GetTasksPix(i);
	//SetWindowPos(tasks[i].hwnd, 0, tasks[i].x, tasks[i].y, ts.Width, ts.Height, NULL); //SWP_NOZORDER|SWP_NOACTIVATE
	if (ts.StartHidden)
		ShowWindow(tasks[i].hwnd, SW_HIDE);
	else
		ShowWindow(tasks[i].hwnd, SW_SHOWNOACTIVATE);
	if (!ts.NoHints)
		CreateHints(tasks[i].hwnd, tasks[i].appTitle);
	//InvalidateRect(tasks[i].hwnd, &r, TRUE);
	return;
}

void DeleteTask(int i)
{
	if (!ts.NoHints)
		RemoveHints(tasks[i].hwnd);
	if (tasks[i].hwnd)
		DestroyWindow(tasks[i].hwnd);
	if (tasks[i].pix)
		DeleteObject(tasks[i].pix);
	if (tasks[i].appClass)
		delete [] tasks[i].appClass;
	if (tasks[i].appTitle)
		delete [] tasks[i].appTitle;
	if (tasks[i].icon && tasks[i].IsCustomIcon)
		DestroyIcon(tasks[i].icon);
	tasks[i].appHandle = NULL;
	tasks[i].hwnd = NULL;
	tasks[i].pix = NULL;
	tasks[i].icon = NULL;  
	tasks[i].appTitle = NULL;
	tasks[i].appClass = NULL;
	return;
}

void GetNewTaskPos(int i)
{
	TaskPosition(i, (ts.AutoArrange ? GetUnMovedNrTasks(): numTasks));
	return;
}

void GetTasks(void)
{/*just trust me on this one, its a mess, but everything is needed :) there a several quirks, and some of the code that seems irrelevant is actually fixing little oddities -jugg*/
	char tmpTitle[MAXLEN], tmpClass[MAXLEN];
	int m, n;
	BOOL refreshTask = false;
	prevTasks = numTasks;
	numTasks = 0;		  
	for (n=0; n<numEnumWin/* && IsWindow(tWinList[n].handle)*/; n++)
	{
		GetWindowText(tWinList[n].handle, (char *)&tmpTitle, MAXLEN);
		GetClassName(tWinList[n].handle, (char *)&tmpClass, MAXLEN);
		if (numTasks < MAXTASKS && (!ts.OnlyMinimized || IsIconic(tWinList[n].handle)) && IsAppWindow(tWinList[n].handle) && !GetTasksIgnore(tmpTitle) && !GetTasksIgnore(tmpClass))
		{
			if (tWinList[n].handle != tasks[numTasks].appHandle)
			{ 
				DeleteTask(numTasks);
				CreateTask(numTasks, tWinList[n].handle);
			}
			if (tasks[numTasks].IsIconic != IsIconic(tWinList[n].handle))
			{
				tasks[numTasks].IsIconic = IsIconic(tWinList[n].handle);
				if (ts.HideMinAppBar) HideMinAppBar(tWinList[n].handle);
				if (tasks[numTasks].IsIconic && tasks[numTasks].IsActive)
				{/*gotta refresh the task if it had been active and highlighting is turned on*/
					tasks[numTasks].IsActive = false;
					if (ts.HighLightSelected)
						refreshTask = true;
				}
				if (ts.TitleMinimized || ts.HighLightMinimized || (!ts.TitleMinimized && (ts.Titles || ts.TitleSelected)))
					refreshTask = true;
			}
			if ((tasks[numTasks].IsActive != (curTask == tasks[numTasks].appHandle)) && ts.HighLightSelected && !tasks[numTasks].IsIconic) /*Strange instance where a minimized window can still be the 'ForegroundWindow'-active?!?*/
			{
				if (curTask == tasks[numTasks].appHandle)
					tasks[numTasks].IsActive = true;
				else
					tasks[numTasks].IsActive = false;
				refreshTask = true;
			}
			if (strcmp(tmpTitle, tasks[numTasks].appTitle) != 0)
			{
				delete [] tasks[numTasks].appTitle;
				tasks[numTasks].appTitle = new char[strlen(tmpTitle) + 1];
				strcpy(tasks[numTasks].appTitle, tmpTitle);
				if (!ts.NoHints) /*This doesn't seem to be updating consistently...-jugg*/
					UpdateHints(tasks[numTasks].hwnd, tasks[numTasks].appTitle);
				if ((ts.Titles && !(tasks[numTasks].IsIconic || tasks[numTasks].IsActive)) || (ts.TitleMinimized && tasks[numTasks].IsIconic) || (ts.TitleSelected && tasks[numTasks].IsActive)) /*Have to force a refresh*/
					refreshTask = true;
			}
			if (tasks[numTasks].icon != GetIconFromWindow(tWinList[n].handle, (ts.IconSize > 23) ? true: false) && !tasks[numTasks].IsCustomIcon && !ts.NoIcons)
			{
				tasks[numTasks].icon = GetIconFromWindow(tWinList[n].handle, (ts.IconSize > 23) ? true: false);
				refreshTask = true;
			}
			if (!ts.StartHidden && refreshTask)
				InvalidateRect(tasks[numTasks].hwnd, NULL, TRUE);
			refreshTask = false;
			numTasks++;
		}
	}
	for (m = numTasks; m < prevTasks; m++)
		DeleteTask(m);
	return;
}

void GetTasksIcon(int n)
{
	int i;
	for (i = 0; i < numIcon; i++)
	{
		if (strstr(tasks[n].appTitle, iconTag[i].match) || strstr(tasks[n].appClass, iconTag[i].match))
		{
			tasks[n].icon = ExtractIcon(dll,iconTag[i].name,iconTag[i].icon);
			if (tasks[n].icon)
			{
				tasks[n].IsCustomIcon = true;
				return;
			}
		}
	}
	tasks[n].icon = GetIconFromWindow(tasks[n].appHandle, (ts.IconSize > 23) ? true: false);
	return;
}

void GetTasksPix(int n)
{
	int i;
	for (i = 0; i < numPix; i++)
	{
		if (strstr(tasks[n].appTitle, pixTag[i].match) || strstr(tasks[n].appClass, pixTag[i].match))
		{
			tasks[n].pix = LoadLSImage(pixTag[i].pix, NULL);
			if (tasks[n].pix)
			{
				tasks[n].icon = NULL;
				return;
			}
		}
	}
	return;
}

void HideMinAppBar(HWND HWnd)
{
	RECT r;
	if (IsIconic(HWnd))
	{
		GetWindowRect(HWnd, &r);
		MoveWindow(HWnd, screenWidth*5+r.left, screenHeight*5+r.top, r.right-r.left, r.bottom-r.top, TRUE);
	}
}

void PackList(HWND hKill)
{/*Modified code from stock LS desktop.dll*/
	int i=0,j;
	for (i=0;i<numEnumWin;i++)
	{
    if ((hKill && tWinList[i].handle == hKill) || (!IsWindow(tWinList[i].handle)))
		{
    	for (j=i;j<numEnumWin-1;j++)
    		memcpy(&tWinList[j], &tWinList[j+1], sizeof(WinList));
			memset(&tWinList[numEnumWin-1], 0, sizeof(WinList));
				//if(IsWindow(tWinList[j+1].handle) && j+1 < numEnumWin)
					//tWinList[j].handle = tWinList[j+1].handle;
				//else
					//tWinList[j+1].handle = NULL;
			//tWinList[numEnumWin-1].handle = NULL;

    	numEnumWin--;
    	//continue;
		}
	}
}

void PaintTask(int i)
{
	int posX, posXpix, posXtmp, posY, posYpix, posYtmp, titleFontSize;
	BOOL activeTask = ts.HighLightSelected && tasks[i].IsActive;
	BOOL minTask = ts.HighLightMinimized && tasks[i].IsIconic;
	BOOL minTitles = ts.TitleMinimized && tasks[i].IsIconic;
	BOOL selTitles = ts.TitleSelected && tasks[i].IsActive;
	BOOL normTitles = ts.Titles && !(tasks[i].IsActive || tasks[i].IsIconic);
	CHAR titleFont[MAXLEN];
	COLORREF bgColor, darkColor, lightColor, titleBgColor, titleDarkColor, titleFontColor, titleLightColor;
	PAINTSTRUCT ps;
	BITMAP bmInfo;
	//HBITMAP backImage; /*using a common backImage doesn't seem to work. Not sure why tho. -jugg*/
	HDC hdc = BeginPaint(tasks[i].hwnd,&ps);
	HDC src = CreateCompatibleDC(NULL);
	if (activeTask)
	{
		//backImage = ts.SelBackImage;
		bgColor = ts.SelBgColor;
		lightColor = ts.SelLightColor;
		darkColor = ts.SelDarkColor;
		titleBgColor = ts.TitleSelBgColor;
		titleDarkColor = ts.TitleSelDarkColor;
		titleFontColor = ts.TitleSelFontColor;
		titleLightColor = ts.TitleSelLightColor;
		strcpy(titleFont, ts.TitleSelFont);
		titleFontSize = ts.TitleSelFontSize;
		posX = ts.SelIconX;
		posY = ts.SelIconY;
		posXpix = ts.SelPixX;
		posYpix = ts.SelPixY;
	}
	else if (minTask)
	{
		//backImage = ts.MinBackImage;
		bgColor = ts.MinBgColor;
		lightColor = ts.MinLightColor;
		darkColor = ts.MinDarkColor;
		titleBgColor = ts.TitleMinBgColor;
		titleDarkColor = ts.TitleMinDarkColor;
		titleFontColor = ts.TitleMinFontColor;
		titleLightColor = ts.TitleMinLightColor;
		strcpy(titleFont, ts.TitleMinFont);
		titleFontSize = ts.TitleMinFontSize;
		posX = ts.MinIconX;
		posY = ts.MinIconY;
		posXpix = ts.MinPixX;
		posYpix = ts.MinPixY;
	}
	else
	{
		//backImage = ts.BackImage;
		bgColor = ts.BgColor;
		lightColor = ts.LightColor;
		darkColor = ts.DarkColor;
		titleBgColor = ts.TitleBgColor;
		titleDarkColor = ts.TitleDarkColor;
		titleFontColor = ts.TitleFontColor;
		titleLightColor = ts.TitleLightColor;
		strcpy(titleFont, ts.TitleFont);
		titleFontSize = ts.TitleFontSize;
		posX = ts.IconX;
		posY = ts.IconY;
		posXpix = ts.PixX;
		posYpix = ts.PixY;
	}
	{/*paint the background unless transparent*/
		RECT r;
		GetClientRect(tasks[i].hwnd, &r);
		if (bgColor != 0x00FF00FF)
			FillRect(hdc, &r, CreateSolidBrush(bgColor));
	}
	if ((ts.BackImage || (ts.SelBackImage && activeTask) || (ts.MinBackImage && minTask)) && !(selBgImgNone && activeTask) && !(minBgImgNone && minTask))
	{/*Paint the background image. Believe me, the above if conditions are all necessary. Odd, but necessary :)*/
		//GetObject(backImage, sizeof(bmInfo), &bmInfo);
		//SelectObject(src, backImage);
		if (ts.MinBackImage && minTask)
		{
			GetObject(ts.MinBackImage, sizeof(bmInfo), &bmInfo);
			SelectObject(src, ts.MinBackImage);
		}
		else if (ts.SelBackImage && activeTask)
		{
			GetObject(ts.SelBackImage, sizeof(bmInfo), &bmInfo);
			SelectObject(src, ts.SelBackImage);
		}
		else
		{
			GetObject(ts.BackImage, sizeof(bmInfo), &bmInfo);
			SelectObject(src, ts.BackImage);
		}
		posXtmp = ts.Width/2 - bmInfo.bmWidth/2;   /*Center in Tile*/
		posYtmp = ts.Height/2 - bmInfo.bmHeight/2;
		TransparentBltLS(hdc, posXtmp, posYtmp, bmInfo.bmWidth, bmInfo.bmHeight, src, 0, 0, RGB(255, 0, 255));
	}
	if (tasks[i].pix)
	{
		GetObject(tasks[i].pix, sizeof(bmInfo), &bmInfo);
		/*Could possibly add code for resizing the pix if larger then available space, with StretchBLT() or something. I don't think its needed tho. -jugg*/
		if (normTitles || minTitles || selTitles)
		{
			posXpix = ts.TitlePixX;
			posYpix = ts.TitlePixY;
		}
		SelectObject(src, tasks[i].pix);
		TransparentBltLS(hdc, posXpix, posYpix, bmInfo.bmWidth, bmInfo.bmHeight, src, 0, 0, RGB(255,0,255));
	}
	else if (tasks[i].icon && !ts.NoIcons)
	{/*If there wasn't a custom pix then use an icon. the 'else if' isn't really needed, since there can never be a valid icon and pix for the same task anyway. But this just makes it safer I guess...*/
		if (normTitles || minTitles || selTitles)
		{
			posX = ts.TitleIconX;
			posY = ts.TitleIconY;
		}
		DrawIconEx(hdc, posX, posY, tasks[i].icon, ts.IconSize, ts.IconSize, 0, NULL, DI_NORMAL);
	}
	if (normTitles || minTitles || selTitles)
	{/*Paint the title boxes -bg/border/text*/
		RECT r;
		GetClientRect(tasks[i].hwnd, &r);
		r.top = ts.TitleY;
		r.left = ts.TitleX;
		r.bottom = ts.TitleHeight + ts.TitleY;
		r.right = ts.TitleWidth + ts.TitleX;
		if (titleBgColor != 0x00FF00FF)
			FillRect(hdc, &r, CreateSolidBrush(titleBgColor));
		if (titleLightColor != 0x00FF00FF)
		{/*Light Color Bevel (left/top)*/
			HPEN pen, oldpen;
			pen = CreatePen(PS_SOLID, 1, titleLightColor);
			oldpen = (HPEN) SelectObject(hdc, pen);
			MoveToEx(hdc, r.left, r.bottom - 1, NULL);
			LineTo(hdc, r.left, r.top);
			LineTo(hdc, r.right - 1, r.top);
			SelectObject(hdc, oldpen);
			DeleteObject(pen);
		}
		if (titleDarkColor != 0x00FF00FF)
		{/*Dark Color Bevel (bottom/right)*/
			HPEN pen, oldpen;
			pen = CreatePen(PS_SOLID, 1, titleDarkColor);
			oldpen = (HPEN) SelectObject(hdc, pen);
			MoveToEx(hdc, r.right - 1, r.top, NULL);
			LineTo(hdc, r.right - 1, r.bottom - 1);
			LineTo(hdc, r.left, r.bottom - 1);
			SelectObject(hdc, oldpen);
			DeleteObject(pen);
		}
		if (titleFontColor != 0x00FF00FF)
		{
			HFONT Font, oldFont;
			int len = strlen(tasks[i].appTitle);
			r.top += 1;
			r.bottom -= 1;
			r.left += 2;
			r.right -= 2;
			Font = CreateFont(titleFontSize, 0, 0, 0, FW_NORMAL, FALSE, (ts.TitleUnderline ? TRUE: FALSE), FALSE, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH|FF_DONTCARE, titleFont);
			oldFont = (HFONT) SelectObject(hdc, Font);
			SetBkMode(hdc, TRANSPARENT);
			SetTextColor(hdc, titleFontColor);
			DrawText(hdc, tasks[i].appTitle, len, &r, DT_VCENTER|DT_SINGLELINE|(ts.TitleNoEllipsis ? 0: DT_END_ELLIPSIS));
			SelectObject(hdc, oldFont);
			DeleteObject(Font);
		}
	}
	{/*Main task border*/
		RECT r;
		GetClientRect(tasks[i].hwnd, &r);
		if (lightColor != 0x00FF00FF)
		{/*Light Color Bevel (left/top)*/
			HPEN pen, oldpen;
			pen = CreatePen(PS_SOLID, 1, lightColor);
			oldpen = (HPEN) SelectObject(hdc, pen);
			MoveToEx(hdc, r.left, r.bottom - 1, NULL);
			LineTo(hdc, r.left, r.top);
			LineTo(hdc, r.right - 1, r.top);
			SelectObject(hdc, oldpen);
			DeleteObject(pen);
		}
		if (darkColor != 0x00FF00FF)
		{/*Dark Color Bevel (bottom/right)*/
			HPEN pen, oldpen;
			pen = CreatePen(PS_SOLID, 1, darkColor);
			oldpen = (HPEN) SelectObject(hdc, pen);
			MoveToEx(hdc, r.right - 1, r.top, NULL);
			LineTo(hdc, r.right - 1, r.bottom - 1);
			LineTo(hdc, r.left, r.bottom - 1);
			SelectObject(hdc, oldpen);
			DeleteObject(pen);
		}
	}
	DeleteDC(src);
	EndPaint(tasks[i].hwnd,&ps);
	//if (backImage)
		//DeleteObject(backImage);
	return;
}

void ReadTasksIcon(void)
{
	FILE * f;
	unsigned int i;
	char * token[4];
	char buffer[1024];
	numIcon = 0;
	f = LCOpen(NULL);
	if (!f) 
		return;
	for (i = 0; i < 4; i++)
		token[i] = new char[MAXLEN];
	while (LCReadNextConfig (f, "*TasksIcon", buffer, sizeof (buffer)))
	{
		int count;
		count = LCTokenize (buffer, token, 4, NULL);
		if (count >= 4)
		{
			iconTag[numIcon].match = new char[strlen(token[1])+1];
			iconTag[numIcon].name = new char[strlen(token[2])+1];
			strcpy(iconTag[numIcon].match, token[1]);
			strcpy(iconTag[numIcon].name, token[2]);
			iconTag[numIcon].icon = atoi(token[3]);
			numIcon++;
		}
	}
	LCClose(f);
	for (i = 0; i < 4; i++)
		delete [] token[i];
	return;
}

void ReadTasksIgnore(void)
{
	FILE * f;
	unsigned int i;
	char * token[2];
	char buffer[1024];
	numIgnore = 0;
	f = LCOpen(NULL);
	if (!f) 
		return;
	for (i = 0; i < 2; i++)
		token[i] = new char[MAXLEN];
	while (LCReadNextConfig (f, "*TasksIgnore", buffer, sizeof (buffer)))
	{
		int count;
		count = LCTokenize (buffer, token, 2, NULL);
		if (count >= 2)
		{
			ignoreTag[numIgnore].match = new char[strlen(token[1])+1];
			strcpy(ignoreTag[numIgnore].match, token[1]);
			numIgnore++;
		}
	}
	LCClose(f);
	for (i = 0; i < 2; i++)
		delete [] token[i];
	return;
}

void ReadTasksPix(void)
{
	FILE * f;
	unsigned int i;
	char * token[3];
	char buffer[1024];
	numPix = 0;
	f = LCOpen(NULL);
	if (!f) 
		return;
	for (i = 0; i < 3; i++)
		token[i] = new char[MAXLEN];
	while (LCReadNextConfig (f, "*TasksPix", buffer, sizeof (buffer)))
	{
		int count;
		count = LCTokenize (buffer, token, 3, NULL);
		if (count >= 3)
		{
			pixTag[numPix].match = new char[strlen(token[1])+1];
			pixTag[numPix].pix = new char[strlen(token[2])+1];
			strcpy(pixTag[numPix].match, token[1]);
			strcpy(pixTag[numPix].pix, token[2]);
			numPix++;
		}
	}
	LCClose(f);
	for (i = 0; i < 3; i++)
		delete [] token[i];
	return;
}

void ReArrangeTasks(BOOL all)
{
	int j = 0;
	for (int i = 0; i < numTasks; i++)
	{
		if (all || !tasks[i].IsMoved)
		{
			TaskPosition(i, j);
			SetWindowPos(tasks[i].hwnd, 0, tasks[i].x, tasks[i].y, ts.Width, ts.Height, NULL); //SWP_NOZORDER|SWP_NOACTIVATE
			j++;
			tasks[i].IsMoved = false; /*when all is true, reset all IsMoved*/
			if (!ts.StartHidden)/*Have to force a complete redraw here...*/
				InvalidateRect(tasks[i].hwnd, NULL, TRUE);
		}
	}
	all = false;
	return;
}

void RemoveHints(HWND hWnd)
{/*from the original ls code (shortcuts)*/
	TOOLINFO ti;/*tool information*/
	RECT r={0,0,0,0};
	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = 0;
	ti.hwnd = hWnd;
	ti.hinst = dll;
	ti.uId = 0;
	ti.lpszText = NULL;
	ti.rect = r;
	SendMessage(hints, TTM_DELTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
	return;
}

void TaskPosition(int i, int tmpNumTasks)
{
	int wrapLine = 0, resetLine = 0, checkLine = 0;
	wrapLine = tmpNumTasks / ts.WrapCount;
	checkLine = tmpNumTasks - ts.WrapCount * wrapLine;
	if (checkLine == 1)
		resetLine = 1;
	else
		resetLine = tmpNumTasks - ts.WrapCount * wrapLine;
	if (ts.Direction == 1) /*up*/
	{
		if (taskWrap)
		{
			if (ts.Y >= 0)
				tasks[i].y = ts.Y - ts.Height - resetLine * (ts.Height + ts.SpacingY);
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y - ts.Height - resetLine * (ts.Height + ts.SpacingY);
			if (ts.WrapDirection == 4) /*left*/
			{
				if (ts.X >= 0)
					tasks[i].x = ts.X - ts.Width - wrapLine * (ts.Width + ts.SpacingX);
				else /*now accepts negative values*/
					tasks[i].x = screenWidth + ts.X - ts.Width - wrapLine * (ts.Width + ts.SpacingX);
			}
			else /*defaults to right, even if user inputs invalid up or down setting*/
			{
				if (ts.X >= 0)
					tasks[i].x = ts.X + wrapLine * (ts.Width + ts.SpacingX);
				else /*now accepts negative values*/
					tasks[i].x = screenWidth + ts.X + wrapLine * (ts.Width + ts.SpacingX);
			}
		}
		else
		{
			if (ts.X >= 0)
				tasks[i].x = ts.X;
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X;
			if (ts.Y >= 0)
				tasks[i].y = ts.Y - ts.Height - tmpNumTasks * (ts.Height + ts.SpacingY);
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y - ts.Height - tmpNumTasks * (ts.Height + ts.SpacingY);
		}
	}
	else if (ts.Direction == 2) /*right*/
	{
		if (taskWrap)
		{
			if (ts.X >= 0)
				tasks[i].x = ts.X + resetLine * (ts.Width + ts.SpacingX);
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X + resetLine * (ts.Width + ts.SpacingX);
			if (ts.WrapDirection == 1) /*up*/
			{
				if (ts.Y >= 0)
					tasks[i].y = ts.Y - ts.Height - wrapLine * (ts.Height + ts.SpacingY);
				else /*now accepts negative values*/
					tasks[i].y = screenHeight + ts.Y - ts.Height - wrapLine * (ts.Height + ts.SpacingY);
			}
			else /*defaults to down, even if user inputs invalid left or right setting*/
			{
				if (ts.Y >= 0)
					tasks[i].y = ts.Y + wrapLine * (ts.Height + ts.SpacingY);
				else /*now accepts negative values*/
					tasks[i].y = screenHeight + ts.Y + wrapLine * (ts.Height + ts.SpacingY);
			}
		}
		else
		{
			if (ts.X >= 0)
				tasks[i].x = ts.X + tmpNumTasks * (ts.Width + ts.SpacingX);
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X + tmpNumTasks * (ts.Width + ts.SpacingX);
			if (ts.Y >= 0)
				tasks[i].y = ts.Y;
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y;
		}
	}
	else if (ts.Direction == 3) /*down*/
	{
		if (taskWrap)
		{
			if (ts.Y >= 0)
				tasks[i].y = ts.Y + resetLine * (ts.Height + ts.SpacingY);
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y + resetLine * (ts.Height + ts.SpacingY);
			if (ts.WrapDirection == 4) /*left*/
			{
				if (ts.X >= 0)
					tasks[i].x = ts.X - ts.Width - wrapLine * (ts.Width + ts.SpacingX);
				else /*now accepts negative values*/
					tasks[i].x = screenWidth + ts.X - ts.Width - wrapLine * (ts.Width + ts.SpacingX);
			}
			else /*defaults to right, even if user inputs invalid up or down setting*/
			{
				if (ts.X >= 0)
					tasks[i].x = ts.X + wrapLine * (ts.Width + ts.SpacingX);
				else /*now accepts negative values*/
					tasks[i].x = screenWidth + ts.X + wrapLine * (ts.Width + ts.SpacingX);
			}
		}
		else
		{
			if (ts.X >= 0)
				tasks[i].x = ts.X;
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X;
			if (ts.Y >= 0)
				tasks[i].y = ts.Y + tmpNumTasks * (ts.Height + ts.SpacingY);
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y + tmpNumTasks * (ts.Height + ts.SpacingY);
		}
	}
	else if (ts.Direction == 4) /*left*/
	{
		if (taskWrap)
		{
			if (ts.X >= 0)
				tasks[i].x = ts.X - ts.Width - resetLine * (ts.Width + ts.SpacingX);
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X - ts.Width - resetLine * (ts.Width + ts.SpacingX);
			if (ts.WrapDirection == 1) /*up*/
			{
				if (ts.Y >= 0)
					tasks[i].y = ts.Y - ts.Height - wrapLine * (ts.Height + ts.SpacingY);
				else /*now accepts negative values*/
					tasks[i].y = screenHeight + ts.Y - ts.Height - wrapLine * (ts.Height + ts.SpacingY);
			}
			else /*defaults to down, even if user inputs invalid left or right setting*/
			{
				if (ts.Y >= 0)
					tasks[i].y = ts.Y + wrapLine * (ts.Height + ts.SpacingY);
				else /*now accepts negative values*/
					tasks[i].y = screenHeight + ts.Y + wrapLine * (ts.Height + ts.SpacingY);
			}
		}
		else
		{
			if (ts.X >= 0)
				tasks[i].x = ts.X - ts.Width - tmpNumTasks * (ts.Width + ts.SpacingX);
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X - ts.Width - tmpNumTasks * (ts.Width + ts.SpacingX);
			if (ts.Y >= 0)
				tasks[i].y = ts.Y;
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y;
		}
	}
	return;
}

void UpdateHints(HWND hwnD, char *txt)
{
	RECT r;
	GetClientRect(hwnD, &r);
	TOOLINFO ti;
	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = TTF_SUBCLASS;
	ti.hwnd = hwnD;
	ti.hinst = dll;
	ti.uId = 0;
	ti.lpszText = txt;
	ti.rect = r;
	SendMessage(hints, TTM_UPDATETIPTEXT, 0, (LPARAM) (LPTOOLINFO) &ti);
	return;
}

/*From here down are the !bang commands*/
void BottomTasks(void)
{
	for (int i = 0; i < numTasks; i++)
	{
		SetParent(tasks[i].hwnd, deskTop);
		//SetWindowPos(tasks[i].hwnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE); //|SWP_NOZORDER|SWP_NOACTIVATE
	}
	ts.AlwaysOnTop = false;
	return;
}

void GatherTasks(void)
{
	ReArrangeTasks(true);
	return;
}

void HideTasks(void)
{
	for (int i = 0; i < numTasks; i++)
		ShowWindow(tasks[i].hwnd, SW_HIDE);
	ts.StartHidden = true;
	return;
}

void ShowTasks(void)
{
	for (int i = 0; i < numTasks; i++)
		ShowWindow(tasks[i].hwnd, SW_SHOWNOACTIVATE);
	ts.StartHidden = false;
	return;
}

void ToggleTasks(void)
{
	for (int i = 0; i < numTasks; i++)
	{
		if (ts.StartHidden)
			ShowWindow(tasks[i].hwnd, SW_SHOWNOACTIVATE);
		else
			ShowWindow(tasks[i].hwnd, SW_HIDE);
	}
	ts.StartHidden = !ts.StartHidden;
	return;
}

void TopTasks(void)
{
	for (int i = 0; i < numTasks; i++)
	{
		SetParent(tasks[i].hwnd, NULL);
		//SetWindowPos(tasks[i].hwnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE); //|SWP_NOZORDER|SWP_NOACTIVATE
	}
	ts.AlwaysOnTop = true;
	return;
}