#ifndef __ACTIVETASKS_H_
#define __ACTIVETASKS_H_

const int MAXLEN = 256;

struct WinList
{
	HWND handle;
};

struct TaskType
{
  char * appTitle;
  char * appClass;
  long x, y;
  HBITMAP pix;
  HICON icon;
  HWND hwnd;
  HWND appHandle;
  BOOL Ignore;
  BOOL IsActive;
  BOOL IsCustomIcon;
  BOOL IsIconic;
  BOOL IsMoved;
};

struct TasksSettings
{
//Main Task Settings
  int Direction, DragDistance, SpacingX, SpacingY, WrapCount, WrapDirection;
  int Height, Width, X, Y;
  int IconSize, IconX, IconY, MinIconX, MinIconY, SelIconX, SelIconY;
  int PixX, PixY, MinPixX, MinPixY, SelPixX, SelPixY;

  BOOL AlwaysOnTop, AutoArrange, HideMinAppBar, InjTray, MoveAll, NoMinimizeOnClick, NoMove, OnlyMinimized, StartHidden;
  BOOL NoHints, NoIcons, HighLightMinimized, HighLightSelected;

  COLORREF BgColor, DarkColor, LightColor, MinBgColor, MinDarkColor, MinLightColor, SelBgColor, SelDarkColor, SelLightColor;

  HBITMAP BackImage, MinBackImage, SelBackImage;

//Title Task Settings
  int TitleHeight, TitleWidth, TitleX, TitleY;
	int TitleIconX, TitleIconY, TitlePixX, TitlePixY;
  int TitleFontSize, TitleMinFontSize, TitleSelFontSize;

  BOOL Titles, TitleMinimized, TitleNoEllipsis, TitleSelected, TitleUnderline;

  CHAR TitleFont[MAXLEN], TitleMinFont[MAXLEN], TitleSelFont[MAXLEN];

  COLORREF TitleBgColor, TitleDarkColor, TitleFontColor, TitleLightColor, TitleMinBgColor, TitleMinDarkColor, TitleMinFontColor, TitleMinLightColor, TitleSelBgColor, TitleSelDarkColor, TitleSelFontColor, TitleSelLightColor;
};

struct IconList
{
  char * match; // string to look for in titlebar, or class name
  char * name; // path to icon
  int icon; // icon # to load when name is found
};

struct IgnoreList
{
  char * match; // string to look for in titlebar, or class name
};

struct PixList
{
  char * match; // string to look for in titlebar, or class name
  char * pix; // path to pix to load
};

#ifdef __cplusplus
extern "C" {
#endif

__declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
__declspec( dllexport ) void quitModule(HINSTANCE dllInst);

#ifdef __cplusplus
}
#endif


#endif

